###############################################################################################
## Program to calculate edge weight using node weights		    ###
## Input : Node weights file, network (edge) file					    ###
###############################################################################################

#!/usr/bin/perl

use strict;
use warnings;
use Math::Complex;

if(@ARGV != 2){
	print "Usage: $0 <node weights file> <edge file>\n";
	exit;
}

sub trim
{
 my @localcpy = @_;
 my @trimarr = ();
 foreach ( @localcpy )  { s/^\s*(.*)\s*$/$1/g; push @trimarr, $_ if( defined $_ and $_ ne '' );}
 return (wantarray)?@trimarr:$trimarr[0];
}

sub cal_ew
{
	my @val = @_;
#	my $ew = (1 / ($val[2] * sqrt(abs($val[0])*abs($val[1])))) * (10 ** 5);
	my $ew = abs($val[0]) * abs($val[1]);
	
	return $ew;
}

open(HN,$ARGV[0]);
my @node_weights;
while(<HN>){
	my $l = $_;
	chomp $l;
	my @nw = trim split(/\s+/,$l);
	push(@node_weights,$nw[0],$nw[1]);
}
my %nw_hash = @node_weights;
close(HN);

open(EB,$ARGV[1]);
while(<EB>){
	my $eb_line = $_;
	chomp $eb_line;
#	print $eb_line;
	my @eb_f = split(/\s+/,$eb_line);
	my $node1_w = $nw_hash{$eb_f[0]};
	my $node2_w = $nw_hash{$eb_f[1]};
#	print "$node1_w\t$node2_w\n";
	if($node1_w && $node2_w){	
	my $ew = cal_ew($node1_w,$node2_w);
	printf ("%s\t%s\t%f\n",$eb_f[0],$eb_f[1],$ew);
	}
}
